<template>
  <div>
    <Loader :display="!series" />
    <div v-if="series" class="serie-section">
      <div
        v-if="series && series.length > 5"
        class="heading heading--with-button trunk"
      >
        <h2 class="heading--lg heading--primary">
          {{ title }}
        </h2>

        <!-- Used in catalog when there is a slug -->
        <a
          v-if="data.slug"
          class="button button_shape button_sm"
          :href="seeAllGenreUrl"
          >{{ $t('findreaders.seeall') }}</a
        >

        <!-- Used by default -->
        <a
          v-else
          class="button button_shape button_sm"
          :href="seeAllDefaultUrl"
          >{{ $t('findreaders.seeall') }}</a
        >
      </div>
      <client-only>
        <slick-slide
          ref="slick"
          :options="slickOptions"
          :class="`${data.reference} ${
            series && series.length > 5
              ? 'products-slick trunk custom-slick'
              : 'no-serie'
          }`"
        >
          <SerieItem
            v-for="(serie, index) of series"
            ref="series"
            :key="serie.id"
            :serie="serie"
            :subscribed="isSubscription"
            :no-price="noPrice"
            :push-impression-click="true"
            :parent-list-name="title"
            :position-in-list="index + 1"
          />
        </slick-slide>
        <template slot="placeholder">
          <SerieItem
            v-for="(serie, index) of series"
            ref="series"
            :key="serie.id"
            :serie="serie"
            :subscribed="isSubscription"
            :no-price="noPrice"
            :push-impression-click="true"
            :parent-list-name="title"
            :position-in-list="index + 1"
          />
        </template>
      </client-only>
    </div>
  </div>
</template>

<script>
import SerieItem from '~/components/SerieItem'
import Loader from '~/components/ui/Loader'

export default {
  components: { SerieItem, Loader },
  props: {
    data: {
      type: Object,
      required: true
    },

    // Used for style and fetching
    isSubscription: {
      type: Boolean,
      require: false,
      default: false
    },

    // Used to load one by one multiple serie sections
    shouldBeLoaded: {
      type: Boolean,
      require: false,
      default: true
    },

    noPrice: {
      type: Boolean,
      require: false,
      default: false
    }
  },
  async fetch() {
    if (process.server) {
      this.title = this.data.title
      this.series = this.data.series || null
      if (this.series) {
        this.isLoading = false
      }
    }
  },
  data() {
    return {
      title: '',
      series: null,
      loading: true,
      slickOptions: {
        dots: false,
        infinite: true,
        slidesToShow: 6,
        slidesToScroll: 6,
        prevArrow: '<button type="button" class="slick-prev"></button>',
        nextArrow: '<button type="button" class="slick-next"></button>',
        lazyLoad: 'ondemand',
        rows: 0, // fix for extra div
        responsive: [
          {
            breakpoint: 1024,
            settings: 'unslick'
          }
        ]
      },
      gtmPushedImpressions: []
    }
  },
  computed: {
    seeAllUrl() {
      let url = `/${this.$i18n.locale}/${this.isAbo ? 'abo/' : ''}serie/${
        this.data.reference
      }`

      if (this.data.itemId !== undefined) {
        url = url + `/${this.data.itemId}`
      }
      return url
    },
    isAbo() {
      return this.$utils.aboArea()
    },
    host() {
      return this.$config.izneoUrl
    },
    seeAllDefaultUrl() {
      let url = `/${this.$i18n.locale}/${this.isAbo ? 'abo/' : ''}serie/${
        this.data.reference
      }`

      if (this.data.itemId !== undefined) {
        url = url + `/${this.data.itemId}`
      } else if (
        this.data.shelf &&
        this.data.reference !== 'top-subscription-reading'
      ) {
        url = url + `/${this.data.shelf}`
      }
      return url
    },
    seeAllGenreUrl() {
      // TODO there is no shelf slug in data to create the url
      return ''
    }
  },
  watch: {
    async shouldBeLoaded() {
      await this.loadData()
    }
  },
  async mounted() {
    await this.loadData()
  },
  beforeDestroy() {
    this.$refs && this.$refs.slick && $(this.$refs.slick.$el).slick('unslick')
  },
  methods: {
    async loadData() {
      this.title = this.data.title

      if (this.shouldBeLoaded) {
        if (!this.data.series) {
          const { reference, shelf, itemId } = this.data
          const subArea = this.isSubscription ? '1' : '0'

          const series = await this.$api.list(
            reference,
            shelf || null,
            itemId || null,
            subArea
          )
          this.series = series
        } else {
          this.series = this.data.series
        }

        // Send an event to parent component v-on:loaded="loadNextSelection()"
        this.$emit('loaded')

        this.contentIsReady()
      }
    },
    contentIsReady() {
      this.loading = false

      if (process.client) {
        window.addEventListener('resize', this.reInit)

        this.$nextTick(() => {
          this.reInit()
        })
      }
    },
    reInit() {
      this.styleBySize()

      if (
        this.series &&
        this.series.length > 0 &&
        this.$refs &&
        this.$refs.slick
      ) {
        if (window.innerWidth > 1024) {
          // init slick
          // push event with first 6 visible series
          if (
            this.series &&
            Array.isArray(this.series) &&
            this.series.length > 5
          ) {
            if (this.gtmPushedImpressions.indexOf(0) < 0) {
              this.gtmCreateAndPushImpressionsFromSeriesList(
                this.series.slice(0, this.slickOptions.slidesToShow),
                this.title
              )
              this.gtmPushedImpressions.push(0)
            }
          }

          $(this.$refs.slick.$el).slick('unslick')
          $(this.$refs.slick.$el)
            .not('slick-initialized')
            .slick(this.slickOptions)

          $(this.$refs.slick.$el).on(
            'afterChange',
            (event, slick, currentSlide) => {
              // there are always 6 items, no need to add
              // each one to gtmPushedImpressions, check/add first one only
              if (this.gtmPushedImpressions.indexOf(currentSlide) < 0) {
                const seriesForImpressions = new Array(this.series.length)
                  .fill(null)
                  .splice(currentSlide, this.slickOptions.slidesToShow)
                  .concat(
                    this.series.slice(
                      currentSlide,
                      currentSlide + this.slickOptions.slidesToShow
                    )
                  )
                this.gtmCreateAndPushImpressionsFromSeriesList(
                  seriesForImpressions,
                  this.title
                )
                this.gtmPushedImpressions.push(currentSlide)
              }
            }
          )
        } else {
          // no slick
          this.gtmPushImpressionsVisible()
          $(this.$refs.slick.$el).on('scroll', () => {
            this.gtmPushImpressionsVisible()
          })
        }
      }
    },
    styleBySize() {
      if (this.$refs && this.$refs.slick) {
        if (this.series && this.series.length > 0 && window.innerWidth > 1024) {
          this.$refs.slick.$el.classList.remove('products-list')
        } else {
          this.$refs.slick.$el.classList.add('products-list')
        }
      }
    },

    isNodeVisible(nodeEl, containerWidth) {
      const rect = nodeEl.getBoundingClientRect()
      return rect.left > 0 && rect.left + rect.width <= containerWidth
    },

    getSerieById(id) {
      return this.series && this.series.length
        ? this.series.filter((s) => +s.id === +id)[0]
        : null
    },

    getVisibleSeries() {
      const c = this.$refs.slick.$el.getBoundingClientRect(),
        serieNodes = this.$refs.series

      return serieNodes.map((serieNode) => {
        if (this.isNodeVisible(serieNode.$el, c.width)) {
          return this.getSerieById(serieNode.$vnode.key)
        }
        return null
      })
    },

    gtmCreateAndPushImpressionsFromSeriesList(list, title) {
      if (!process.client) return

      const impressions = []
      list.forEach((serie, ind) => {
        if (serie) {
          impressions.push(
            this.$utils.gtmAdvEcommerceCreateProductImpression(
              serie.title,
              serie.id,
              serie.minPrice ?? '',
              serie.shelf,
              'Series',
              title,
              ind + 1
            )
          )
        }
      })

      if (impressions.length) {
        this.$utils.gtmAdvEcommercePushProductImpressions(impressions)
      }
    },

    gtmPushImpressionsVisible() {
      const visibleSeries = this.getVisibleSeries()

      // get not added to impression list
      const newVisibleSeries = visibleSeries.map((serie) =>
        serie && this.gtmPushedImpressions.indexOf(serie.id) < 0 ? serie : null
      )

      this.gtmCreateAndPushImpressionsFromSeriesList(
        newVisibleSeries,
        this.title
      )
      newVisibleSeries.forEach((serie) => {
        if (serie) {
          this.gtmPushedImpressions.push(serie.id)
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.client-only-placeholder {
  display: flex;
  flex-direction: row;
  max-width: 1260px;
  margin: auto;
  flex-wrap: wrap;
}
</style>

<style lang="scss">
@import '~/assets/scss/utilities/custom-slick.scss';

.serie-section {
  .no-serie {
    display: none;
  }

  .products-slick_wrapper {
    text-align: center;
    box-shadow: inset 0 1px 10px 0 rgba(0, 0, 0, 0.1);
    padding: 20px 0 30px;
  }

  .products-slick_wrapper-library {
    display: none;
  }

  .products-slick {
    margin-bottom: 36px;

    &.trunk {
      padding-left: 10px;
      padding-right: 0;
    }

    @media only screen and (max-width: 767px) {
      &.trunk {
        padding-left: 20px;
        padding-right: 20px;
      }
      .slick-arrow {
        display: none !important;
      }
    }
  }
}
</style>
